VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.ActiveVB.de - Dezimal / Binr umrechnung"
   ClientHeight    =   2145
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5640
   LinkTopic       =   "Form1"
   ScaleHeight     =   2145
   ScaleWidth      =   5640
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command2 
      Caption         =   "<<"
      Height          =   255
      Left            =   2160
      TabIndex        =   5
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   ">>"
      Height          =   255
      Left            =   2160
      TabIndex        =   4
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   3720
      TabIndex        =   3
      Top             =   960
      Width           =   1695
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Text            =   "101010111"
      Top             =   960
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Binr:"
      Height          =   255
      Left            =   3720
      TabIndex        =   1
      Top             =   600
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Dezimal:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor: Strubel
'
'Kommentare, berarbeitung und Erklrung
'des Umrechnungsverfahrens: Thomas Rodemer (Thomas@ActiveVB.de)

Option Explicit


' Erklrung des Umrechnungsverfahrens
' ===================================
' Um aus einem Binr Wert eine Zahl zu errechnen geht man wie folgt vor:
' Man nummeriert alle Stellen beginnend mit dem niederwertigsten Bit (das
' ganz rechts steht) das den Stellenwert 0 hat bis nach ganz links zum
' hchstwertigsten.
' Danach werden alle Stellen an denen eine 1 steht durch 2^Stellenwert
' ersetzt.
' Abschlieend werden alle Werte miteinander addiert.
'
' Bsp:
' Binrwert:                 1 0 0 1 0 1 0 1
'
' Stellen nummerieren:       7 6 5 4 3 2 1 0
'
' Alle "1" heraussuchen      V     V   V   V
' 2^stellenwert ergibt      128   16   4   1
'                           -----------------
' Alles Addieren:               ==>  149



Private Function Bin2Dec(ByVal Bin As String) As Long
' Von Binaer nach Dezimal umrechnen
Dim i As Long, lngLen As Long
lngLen = Len(Bin)                   ' Lnge der Binrzahl
For i = lngLen To 1 Step -1         ' Fr jede Stelle die Schleife durchgehen
     Bin2Dec = Bin2Dec + IIf(Mid$(Bin, i, 1) = "1", 2 ^ (lngLen - i), 0)
                                    ' umrechnen in Dezimal (siehe Erklrung oben)
Next i
End Function
 
Private Function Dec2Bin(ByVal Dec As Long) As String
' Von Dezimal in Binaer
Dim Rest As Long
Do
      Rest = Dec Mod 2              ' Den Rest bei einer Division durch 2 errechnen
      Dec2Bin = Rest & Dec2Bin      ' Rest und bishereige Binaer Zahl zusammentun
      Dec = Dec \ 2                 ' Dezimal Zahl durch 2 Teilen
Loop Until Dec = 0                  ' Solange bis Dezimal-Zahl = 0 ist
End Function
Private Sub Command1_Click()
Text2.Text = Bin2Dec(Text1.Text)    ' Aufruf der Funktion Binaer zu Dezimal
End Sub

Private Sub Command2_Click()
Text1.Text = Dec2Bin(Val(Text2.Text)) ' Aufruf der Funktion Dezimal zu Binaer
End Sub

